<copyright> TESLA Callable class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1999 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: Callable.t,v 1.2 1999/09/13 20:42:27 tiggr Exp $</id>
    </copyright>

<doc> {Callable} is a superclass for something that can be called, i.e.,
    code that can be invoked.  Currently, this applies to {CustomMethod}s
    and {BlockDefinition}s.  </doc>
implementation class
Callable: State, mu

end;

implementation instance
Callable
{
  <doc> The arguments to this callable.  The number of {arguments} can be
      one less than the number of name parts.  </doc>
  MutableArray arguments;

  <doc> The arguments, keyed on their name.  This includes the implicit
      arguments {self} and {cmd} (or {block-self} and {block-cmd}).  </doc>
  MutableDictionary argument_singles;
}

void
  addArgument Argument a
{
  if (!arguments)
    arguments = [MutableObjectArray new];
  [arguments add a];
  [a feedArgumentSinglesTo self];
}

void
  addArgumentSingle ArgumentSingle a
{
  argument_singles[[a name]] = a;
}

ArgumentSingle (arg)
  argumentNamed String name
{
  arg = argument_singles[name];
}

Indexed
  arguments
{
  = arguments;
}

deferred Indexed
  name_parts;

end;
