<copyright> MU Invocation.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1997 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: Invocation.t,v 1.12 1998/05/25 20:44:23 tiggr Exp $</id>
    </copyright>

/******************** Invocation ********************/

implementation class
Invocation: Expression

end;

implementation instance
Invocation
{
  <doc> The arguments to this invocation.  The elements are {Expression}
      instances (probably from a subclass, actually).  </doc>
  MutableArray arguments;
}

<doc> Designated initializer.  </doc>
id
  initWithType Type t
     arguments MutableArray a
{
  arguments = a;
  = [super initWithType t];
}

<doc> Return the {arguments}.  </doc>
Indexed
  arguments
{
  = arguments;
}

<doc> Emit the {arguments}, if not {nil}.  </doc>
OutputStream
  writeFields OutputStream s
{
  s = [super writeFields s];
  = !arguments ? s : [s print (" args=", arguments)];
}

end;

/******************** UnresolvedInvocation ********************/

implementation class
UnresolvedInvocation: Invocation

end;

implementation instance
UnresolvedInvocation
{
  <doc> The receiver.  </doc>
  Expression receiver;

  <doc> The nameparts corresponding to the arguments.  </doc>
  Indexed name_parts;

  <doc> The confined super, if specified.  </doc>
  Meta confined;

  <doc> Iff {TRUE}, this is a message to super.  </doc>
  boolean is_super;

  <doc> Iff {TRUE}, this is a message to the class of the type of the
      {receiver}.  </doc>
  mutable boolean is_class;
}

<doc> Designated initializer.  </doc>
id
  initWithReceiver (Expression, Meta, boolean) (rcv, conf, do_super)
         nameParts Indexed parts
	 arguments MutableArray args
pre
  ((rcv != nil || do_super)
   && ((!args && [parts length] == 1)
       || [parts length] - [args length] <= 1))
{
  (receiver, name_parts) = (rcv, parts);
  (is_super, confined) = (do_super, conf);
  = [super initWithType nil arguments args];
}

<doc> Emit the {receiver} and {name_parts}.  </doc>
OutputStream
  writeFields OutputStream s
{
  = [[super writeFields s] print (" names=", name_parts, " rcv=", receiver)];
}

end;

/******************** UnresolvedOperatorInvocation ********************/

implementation class
UnresolvedOperatorInvocation: UnresolvedInvocation

end;

implementation instance
UnresolvedOperatorInvocation
{
  <doc> The operator.  </doc>
  public int operator;

  <doc> Only important for unary operators, this is {TRUE} iff it was used
      postfix.  </doc>
  public boolean postfixed;
}

<doc> Designated initializer.  </doc>
id
  initWithReceiver Expression rcv
	 arguments MutableArray a
	  operator int op
	postfixed: boolean postfix = NO
{
  (operator, postfixed) = (op, postfix);

  String name = operator_names[operator];
  = [super initWithReceiver (rcv, nil, FALSE)
	   nameParts (op >= OP_NOT && op < OP_AT ? [ObjectArray with name]
		      : [ObjectArray with (name, [UniqueString with ":"])])
	   arguments a];
}

end;
